<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Creating New Entries</TITLE>
<link href="suif1_49.html" rel=Next>
<link href="suif1_47.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_47.html">previous</A>, <A HREF="suif1_49.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC48" HREF="suif1_toc.html#TOC48">Creating New Entries</A></H2>

<P>
To make it easier to add new entries, the symbol tables provide methods
that combine the steps of creating new objects and then entering them in
the tables.  Some of these methods automatically make sure that the new
entries have unique names and that is particularly useful.

</P>
<P>
<A NAME="IDX302"></A>
<A NAME="IDX303"></A>
New variables can be added to tables anywhere in the symbol table
hierarchy.  The <CODE>new_var</CODE> method creates a new variable with a
given name and type and then enters the new variable symbol in the
table.  The <CODE>new_unique_var</CODE> method is similar, but it also checks
that the name of the new variable is unique.  If not, it appends a
number to the specified name until it is unique.  With this method, the
base name is optional; the default value is <SAMP>`suif_tmp'</SAMP>.

</P>
<P>
<A NAME="IDX304"></A>
Procedure symbols can be created in global and file symbol tables using
the <CODE>new_proc</CODE> method.  The name of the procedure, its type, and
the source language must be specified.  There is currently no method to
automatically create a new procedure symbol with a unique name.

</P>
<P>
<A NAME="IDX305"></A>
<A NAME="IDX306"></A>
Because label symbols may only be declared within procedures, the
<CODE>new_label</CODE> and <CODE>new_unique_label</CODE> methods are provided in the
<CODE>block_symtab</CODE> class.  The only parameter of these methods is the
name of the label.  The name is optional for <CODE>new_unique_label</CODE>;
its default value is <SAMP>`L'</SAMP>.  Just as with variables, unique label
names are created by adding a number to the end of the base names.

</P>
<P>
<A NAME="IDX307"></A>
Within a procedure, new inner scopes may be created to be used with new
<CODE>tree_block</CODE> nodes.  The <CODE>block_symtab</CODE> class provides the
<CODE>new_unique_child</CODE> method to create a new symbol table, give it a
unique name, and add it to the list of children.  The unique name is
created by appending a number to the optional base name.  If the base
name is not given, it defaults to <SAMP>`block'</SAMP>.  This method is not
needed at the global level, because the child symbol tables there
correspond to procedures which should already have unique names.

</P>
<P>
<A NAME="IDX308"></A>
Finally, new variable definitions can be added to any symbol table using
the <CODE>define_var</CODE> method.  The parameters are the variable symbol
and the alignment for the storage to be defined.  It returns a pointer
to the new variable definition object, so that you can attach initial
data annotations to it.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_47.html">previous</A>, <A HREF="suif1_49.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
